using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Linq;
using System.Text;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_KnowledgeReporting
    /// </summary>
    public partial class T_KnowledgeReporting
    {
        public T_KnowledgeReporting()
        { }
        #region  BasicMethod



        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(Model.T_KnowledgeReporting model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_KnowledgeReporting(");
            strSql.Append("F_Type,F_Content,F_Score,F_Deptid,F_CreateTime,F_LimitTime,F_Seats,F_ReplyContent,F_CreateUser,F_UpdateTime,F_UpdateUser,F_State,F_ReportingTime,F_ReportingUser,F_ReplyTime,F_IsDelete,F_Title,F_IsReply,F_AuditOpinion,F_AuditTime)");
            strSql.Append(" values (");
            strSql.Append("@F_Type,@F_Content,@F_Score,@F_Deptid,@F_CreateTime,@F_LimitTime,@F_Seats,@F_ReplyContent,@F_CreateUser,@F_UpdateTime,@F_UpdateUser,@F_State,@F_ReportingTime,@F_ReportingUser,@F_ReplyTime,@F_IsDelete,@F_Title,@F_IsReply,@F_AuditOpinion,@F_AuditTime)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_Content", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_Score", SqlDbType.Float,8),
                    new SqlParameter("@F_Deptid", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_LimitTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Seats", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_ReplyContent", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_CreateUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_UpdateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_UpdateUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_ReportingTime", SqlDbType.DateTime),
                    new SqlParameter("@F_ReportingUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_IsReply", SqlDbType.Int,4),
                    new SqlParameter("@F_Title", SqlDbType.NVarChar,200),
                     new SqlParameter("@F_AuditOpinion", SqlDbType.NVarChar,-1),
                      new SqlParameter("@F_AuditTime", SqlDbType.DateTime ),
                  
                    new SqlParameter("@F_ReplyTime", SqlDbType.DateTime)};
            parameters[0].Value = model.F_Type;
            parameters[1].Value = model.F_Content;
            parameters[2].Value = model.F_Score;
            parameters[3].Value = model.F_Deptid;
            parameters[4].Value = model.F_CreateTime;
            parameters[5].Value = model.F_LimitTime;
            parameters[6].Value = model.F_Seats;
            parameters[7].Value = model.F_ReplyContent;
            parameters[8].Value = model.F_CreateUser;
            parameters[9].Value = model.F_UpdateTime;
            parameters[10].Value = model.F_UpdateUser;
            parameters[11].Value = model.F_State;
            parameters[12].Value = model.F_ReportingTime;
            parameters[13].Value = model.F_ReportingUser;
            parameters[14].Value = model.F_IsDelete;
            parameters[15].Value = model.F_IsReply;
            parameters[16].Value = model.F_Title;
            parameters[17].Value = model.F_AuditOpinion;
            parameters[18].Value = model.F_AuditTime;
            
            parameters[19].Value = model.F_ReplyTime;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.T_KnowledgeReporting model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_KnowledgeReporting set ");
            strSql.Append("F_Type=@F_Type,");
            strSql.Append("F_Content=@F_Content,");
            strSql.Append("F_Score=@F_Score,");
            strSql.Append("F_Deptid=@F_Deptid,");
            strSql.Append("F_CreateTime=@F_CreateTime,");
            strSql.Append("F_LimitTime=@F_LimitTime,");
            strSql.Append("F_Seats=@F_Seats,");
            strSql.Append("F_ReplyContent=@F_ReplyContent,");
            strSql.Append("F_CreateUser=@F_CreateUser,");
            strSql.Append("F_UpdateTime=@F_UpdateTime,");
            strSql.Append("F_UpdateUser=@F_UpdateUser,");
            strSql.Append("F_State=@F_State,");
            strSql.Append("F_ReportingTime=@F_ReportingTime,");
            strSql.Append("F_ReportingUser=@F_ReportingUser,");
            strSql.Append("F_IsDelete=@F_IsDelete,");
            strSql.Append("F_IsReply=@F_IsReply,");
            strSql.Append("F_Title=@F_Title,");
            strSql.Append("F_AuditOpinion=@F_AuditOpinion,");
            strSql.Append("F_AuditTime=@F_AuditTime,");
            
            strSql.Append("F_ReplyTime=@F_ReplyTime");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_Content", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_Score", SqlDbType.Float,8),
                    new SqlParameter("@F_Deptid", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_LimitTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Seats", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_ReplyContent", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_CreateUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_UpdateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_UpdateUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_ReportingTime", SqlDbType.DateTime),
                    new SqlParameter("@F_ReportingUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_IsReply", SqlDbType.Int,4),
                    new SqlParameter("@F_Title", SqlDbType.NVarChar,200),
                     new SqlParameter("@F_AuditOpinion", SqlDbType.NVarChar,-1),
                      new SqlParameter("@F_AuditTime", SqlDbType.DateTime),
                    
                    new SqlParameter("@F_ReplyTime", SqlDbType.DateTime),
                    new SqlParameter("@F_ID", SqlDbType.Int,4)};
            parameters[0].Value = model.F_Type;
            parameters[1].Value = model.F_Content;
            parameters[2].Value = model.F_Score;
            parameters[3].Value = model.F_Deptid;
            parameters[4].Value = model.F_CreateTime;
            parameters[5].Value = model.F_LimitTime;
            parameters[6].Value = model.F_Seats;
            parameters[7].Value = model.F_ReplyContent;
            parameters[8].Value = model.F_CreateUser;
            parameters[9].Value = model.F_UpdateTime;
            parameters[10].Value = model.F_UpdateUser;
            parameters[11].Value = model.F_State;
            parameters[12].Value = model.F_ReportingTime;
            parameters[13].Value = model.F_ReportingUser;
            parameters[14].Value = model.F_IsDelete;
            parameters[15].Value = model.F_IsReply;
            parameters[16].Value = model.F_Title;
            parameters[17].Value = model.F_AuditOpinion;
            parameters[18].Value = model.F_AuditTime;
            
            parameters[19].Value = model.F_ReplyTime;
            parameters[20].Value = model.F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_KnowledgeReporting ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_IDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_KnowledgeReporting set F_IsDelete=1");
            strSql.Append(" where F_ID in (" + F_IDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
           
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_KnowledgeReporting GetModel(int F_ID)
        {
             
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ID,F_Type,F_Content,F_Score,F_Title,F_Deptid,F_CreateTime,F_LimitTime,F_Seats,F_ReplyContent,F_CreateUser,F_UpdateTime,F_UpdateUser,F_State,F_ReportingTime,F_ReportingUser,F_ReplyTime,F_IsDelete,F_IsReply,F_AuditOpinion,F_AuditTime from T_KnowledgeReporting ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            Model.T_KnowledgeReporting model = new Model.T_KnowledgeReporting();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_KnowledgeReporting DataRowToModel(DataRow row)
        {
            Model.T_KnowledgeReporting model = new Model.T_KnowledgeReporting();
            if (row != null)
            {
                if (row["F_ID"] != null && row["F_ID"].ToString() != "")
                {
                    model.F_ID = int.Parse(row["F_ID"].ToString());
                }
                if (row["F_Type"] != null && row["F_Type"].ToString() != "")
                {
                    model.F_Type = int.Parse(row["F_Type"].ToString());
                }
                if (row["F_Content"] != null)
                {
                    model.F_Content = row["F_Content"].ToString();
                }
                if (row["F_Score"] != null && row["F_Score"].ToString() != "")
                {
                    model.F_Score = decimal.Parse(row["F_Score"].ToString());
                }
                if (row["F_Deptid"] != null && row["F_Deptid"].ToString() != "")
                {
                    model.F_Deptid = int.Parse(row["F_Deptid"].ToString());
                }
                if (row["F_IsDelete"] != null && row["F_IsDelete"].ToString() != "")
                {
                    model.F_IsDelete = int.Parse(row["F_IsDelete"].ToString());
                }
                if (row["F_CreateTime"] != null && row["F_CreateTime"].ToString() != "")
                {
                    model.F_CreateTime = DateTime.Parse(row["F_CreateTime"].ToString());
                }
                if (row["F_LimitTime"] != null && row["F_LimitTime"].ToString() != "")
                {
                    model.F_LimitTime = DateTime.Parse(row["F_LimitTime"].ToString());
                }
                if (row["F_Seats"] != null)
                {
                    model.F_Seats = row["F_Seats"].ToString();
                }
                if (row["F_ReplyContent"] != null)
                {
                    model.F_ReplyContent = row["F_ReplyContent"].ToString();
                }
                if (row["F_CreateUser"] != null)
                {
                    model.F_CreateUser = row["F_CreateUser"].ToString();
                }
                if (row["F_UpdateTime"] != null && row["F_UpdateTime"].ToString() != "")
                {
                    model.F_UpdateTime = DateTime.Parse(row["F_UpdateTime"].ToString());
                }
                if (row["F_UpdateUser"] != null)
                {
                    model.F_UpdateUser = row["F_UpdateUser"].ToString();
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
                if (row["F_IsReply"] != null && row["F_IsReply"].ToString() != "")
                {
                    model.F_IsReply = int.Parse(row["F_IsReply"].ToString());
                }
                if (row["F_ReportingTime"] != null && row["F_ReportingTime"].ToString() != "")
                {
                    model.F_ReportingTime = DateTime.Parse(row["F_ReportingTime"].ToString());
                }
                if (row["F_ReportingUser"] != null)
                {
                    model.F_ReportingUser = row["F_ReportingUser"].ToString();
                }
                if (row["F_ReplyTime"] != null && row["F_ReplyTime"].ToString() != "")
                {
                    model.F_ReplyTime = DateTime.Parse(row["F_ReplyTime"].ToString());
                }
                if (row["F_Title"] != null)
                {
                    model.F_Title = row["F_Title"].ToString();
                }
                if (row["F_AuditOpinion"] != null)
                {
                    model.F_AuditOpinion = row["F_AuditOpinion"].ToString();
                }
                if (row["F_AuditTime"] != null && row["F_AuditTime"].ToString() != "")
                {
                    model.F_AuditTime = DateTime.Parse(row["F_AuditTime"].ToString());
                }
               
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
             
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_ID,F_Type,F_Content,F_Score,F_Deptid,F_CreateTime,F_LimitTime,F_Seats,F_ReplyContent,F_CreateUser,F_UpdateTime,F_UpdateUser,F_State,F_ReportingTime,F_ReportingUser,F_ReplyTime,F_Title,F_IsReply ,F_AuditOpinion,F_AuditTime");
            strSql.Append(" FROM T_KnowledgeReporting ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            
            strSql.Append(" F_ID,F_Type,F_Content,F_Score,F_Deptid,F_CreateTime,F_LimitTime,F_Seats,F_ReplyContent,F_CreateUser,F_UpdateTime,F_UpdateUser,F_State,F_ReportingTime,F_ReportingUser,F_ReplyTime,F_Title,F_IsReply ,F_AuditOpinion,F_AuditTime");
            strSql.Append(" FROM T_KnowledgeReporting ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_KnowledgeReporting ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ID desc");
            }
            strSql.Append(")AS Row, T.*  from T_KnowledgeReporting T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_KnowledgeReporting";
			parameters[1].Value = "F_ID";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
